import React from 'react';
import ReactDOM from 'react-dom';
import { useData } from './useData';
import { Marks } from './Marks';

//defining svg graphic dimensions
const width = 960;
const height = 500;

//useData() is used to share data across components based on hooks
const App = () => {
  const data = useData();

//Displays Loading where there is no data
  if (!data) {
    return <pre>Loading...</pre>;
  }

//Displays the svg graphic if there is data
  return (
    <svg width={width} height={height}>
      <Marks data={data} />
    </svg>
  );
};

//To render a React element, first pass the DOM element to ReactDOM.createRoot(), 
	//then pass the React element to root.render()
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
