//import React and some hooks from react
import React, { useState, useEffect } from 'react';

//import json() from D3
import { json } from 'd3';

//importing feature() and mesh() from TopoJSON
import { feature, mesh } from 'topojson';

//The link contains the geographic data of all the states in USA
const jsonUrl = 'https://unpkg.com/us-atlas@3.0.0/states-10m.json';

//useData() is used to share data across components based on hooks
export const useData = () => {
  const [data, setData] = useState(null);

//useEffect() performs side effects in function components
  useEffect(() => {
    json(jsonUrl).then(topology => {
      
//assigning the ojects to 'states' constant      
      const { states } = topology.objects;
      setData({
        land: feature(topology, states),
        interiors: mesh(topology, states, (a, b) => a !== b)
      });
    });
  }, []);

//return the map
  return data;
};